import { useState } from "react";
import { sortableContainer, sortableElement } from 'react-sortable-hoc';
import { arrayMoveImmutable } from 'array-move';
import { backendURL} from '../requests/reducers';
import { connect } from 'react-redux';
import { actionAdUpsert } from "../requests/actions";


const defaultAd = {
    "_id": "5e8dc32942ab995bb1706662",
    "title": "second post",
    "comments": null,
    "images": [
        {
            "_id": "5e8dc1fc42ab995bb1706660",
            "url": "images/00e734a765bb89be183727f2404be689"
        },
        {
            "_id": "5e8dc1fd42ab995bb1706661",
            "url": "images/60a5fa93cbae5d144cb215f0222e5bef"
        }
    ]
};


const SortableItem = sortableElement(({ url }) => (
    <li>
        <img
            src={backendURL + '/' + url}
            style={{ maxWidth: '200px', maxHeight: '200px' }}
        />
    </li>
));

const SortableContainer = sortableContainer(({ children }) => {
    return <ul>{children}</ul>
});



const AdEditor = ({ ad = defaultAd, onSave, onFileDrop, fileStatus }) => {
    const [state, setState] = useState(ad)
    const onSortEnd = ({ oldIndex, newIndex }) => {
        setState({
            ...state,
            images: arrayMoveImmutable(state.images, oldIndex, newIndex),
        })
       
    }
    // onFileDrop();
    // fileStatus
   
    // useEffect(() => { if (fileStatus.status===resolved) { } }, [fileStatus]);
    return (<>
      <SortableContainer onSortEnd={onSortEnd}>
            {state.images.map(({ _id, url }, index) => (
                <SortableItem key={`item - ${_id}`} index={index} url={url}/>
        ))}
      </SortableContainer>
      <button onClick={() => onSave(state)}> Save </button>
    </>
  )
}

// const EntityEditor = ({entity={array: []}, onSave, onFileDrop, fileStatus}) => {
//     const [state,setState] = useState(entity)
    //по файлу в дропзоне:
        //дергать onFileDrop
        //fileStatus - информация о заливке файла из redux
        //через useEffect дождаться когда файл зальется
        //и сделать setState({...state, array: [...state.array, {объект файла с бэка с _id и url}]})
    //по react-sortable-hoc
        //делаете как в пример arrayMove для state.array
    //по кнопке сохранения делаем onSave(state)
    //где-то рядом остальные поля из state типа title name text
    //но это вы уже знаете
// }

const CAd = connect(null, { onSave: actionAdUpsert })(AdEditor);
// const CAdEdit = connect(state => ({ fileStatus:state.promise.}), { onSave: actionAdUpsert })(AdEditor);
export {CAd };